//+------------------------------------------------------------------+
//|                                                     DTOmulty.mq4 |
//|                                                  Copyleft  2009 |
//|                                                                  |
//+------------------------------------------------------------------+

#property  indicator_separate_window
#property indicator_buffers     2
#property indicator_color1      DodgerBlue
#property indicator_color2      Red
#property indicator_width1      2
#property indicator_width2      1
#property indicator_level1      25
#property indicator_level2      75
#property indicator_levelcolor  Gray

//---- input parameters
extern int       rsiLength=13;
extern int       kLength=12;
extern int       DLength=3;
extern int       KSmooth=6;

extern bool      SmoothKLine=true;
extern int    NumPairs = 8;
extern int    TF       = 0;
extern string Pairs1   = "GBPUSD";
extern string Pairs2   = "EURJPY";
extern string Pairs3   = "AUDUSD";
extern string Pairs4   = "NZDJPY";
extern string Pairs5   = "EURUSD";
extern string Pairs6   = "GBPJPY";
extern string Pairs7   = "NZDUSD";
extern string Pairs8   = "AUDJPY";
extern string Pairs9   = "CHFJPY";
extern string Pairs10  = "EURCHF";
extern string Pairs11  = "GBPCHF";
extern string Pairs12  = "USDJPY";
extern string Pairs13  = "CADJPY";
extern string Pairs14  = "EURGBP";
extern int    Mode     = 0;
extern int    Limit    = 1440;


double buf0[], buf1[], buf2[], buf3[], buf4[];
double buftmp[];
string Pairs[];
int bar[][2];
double mPoint[];
bool Recalculate=true;
bool buy_gudok=false;
bool sell_gudok=false;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   IndicatorShortName("DTOMulty("+NumPairs+")("+TF+")");
   IndicatorBuffers(2);
      // +++ by JG +++ //
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
//   SetIndexStyle(0,DRAW_LINE,0,1);
//   SetIndexStyle(1,DRAW_LINE,2,1);
      // --- by JG --- //
   SetIndexBuffer(0,buf0);
   SetIndexBuffer(1,buf1);
   ArrayResize(Pairs,NumPairs);
   ArrayResize(bar,NumPairs);
   ArrayResize(mPoint,NumPairs);
   ArrayInitialize(mPoint,1);
   if (NumPairs > 0) Pairs[0] = Pairs1;
   if (NumPairs > 1) Pairs[1] = Pairs2;
   if (NumPairs > 2) Pairs[2] = Pairs3;
   if (NumPairs > 3) Pairs[3] = Pairs4;
   if (NumPairs > 4) Pairs[4] = Pairs5;
   if (NumPairs > 5) Pairs[5] = Pairs6;
   if (NumPairs > 6) Pairs[6] = Pairs7;
   if (NumPairs > 7) Pairs[7] = Pairs8;
   if (NumPairs > 8) Pairs[8] = Pairs9;
   if (NumPairs > 9) Pairs[9] = Pairs10;
   if (NumPairs > 10) Pairs[10] = Pairs11;
   if (NumPairs > 11) Pairs[11] = Pairs12;
   if (NumPairs > 12) Pairs[12] = Pairs13;
   if (NumPairs > 13) Pairs[13] = Pairs14;
   GetLastError();
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit,err;
   
   int counted_bars = IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   err=GetLastError();
   if (err==4066) {
      counted_bars=0;
      Recalculate=true;
   }
   else {
      if (Recalculate) {
         counted_bars=0;
         Recalculate=false;
      }
   }
   limit = Bars - counted_bars-1;
   int i, j;
   double kk0, kk1;
   if (limit>Limit && Limit>0) limit=Limit;
   for(i = limit; i > -1; i--) {
      kk0 = 0.0;
      kk1 = 0.0;
      int timebar=iTime(NULL,TF,i);
      
      for(j = 0; j < NumPairs; j++) {
         int shift=iBarShift(Pairs[j],TF,timebar);
         if (iTime(NULL,TF,i)<iTime(Pairs[j],TF,shift)) shift++;
         kk0 = kk0 + iCustom(Pairs[j], TF,"DTOsc",rsiLength,kLength,KSmooth,DLength,SmoothKLine,0, shift);
         kk1 = kk1 + iCustom(Pairs[j], TF,"DTOsc",rsiLength,kLength,KSmooth,DLength,SmoothKLine,1, shift);
      }
      buf0[i] = kk0/NumPairs;
      buf1[i] = kk1/NumPairs;
 if (i==0)
 {
   if (buf1[i] >= 75 && buf1[i]>buf0[i] && sell_gudok)
   {
   Alert("  ");
   sell_gudok=false;
   buy_gudok=true;
   }
   if (buf1[i] <= 25 && buf1[i]<buf0[i] && buy_gudok)
   {
   Alert("  ");
   sell_gudok=true;
   buy_gudok=false;
   }
   }
  }
   return(0);
}

