//+------------------------------------------------------------------+
//|                                                     AO multy.mq4 |
//|                         Copyright  2007, Vorobev Software Corp. |
//|                                               ovorobev@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Vorobev Software Corp."
#property link      "ovorobev@gmail.com"

//   
//    
//     
//      
//        

#property  indicator_separate_window
#property indicator_buffers     2
#property indicator_color1      Green
#property indicator_color2      Red
#property indicator_width1      1
#property indicator_width2      1
#property indicator_level1      0

#property indicator_levelcolor  Gray
//---- input parameters
extern int    rvi_per=10;

extern int    NumPairs = 8;
extern int    TF       = 15;
extern string Pairs1   = "GBPUSD";
extern string Pairs2   = "EURJPY";
extern string Pairs3   = "AUDUSD";
extern string Pairs4   = "NZDJPY";
extern string Pairs5   = "EURUSD";
extern string Pairs6   = "GBPJPY";
extern string Pairs7   = "NZDUSD";
extern string Pairs8   = "AUDJPY";
extern string Pairs9   = "CHFJPY";
extern string Pairs10  = "EURCHF";
extern string Pairs11  = "GBPCHF";
extern string Pairs12  = "USDJPY";
extern string Pairs13  = "CADJPY";
extern string Pairs14  = "EURGBP";

extern int    Limit    = 1440;


double buf0[], buf1[];
string Pairs[];
bool Recalculate=true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   IndicatorShortName("RVIMulty("+NumPairs+")("+TF+")");
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(0,buf0);
   SetIndexBuffer(1,buf1);
   ArrayResize(Pairs,NumPairs);

   if (NumPairs > 0) Pairs[0] = Pairs1;
   if (NumPairs > 1) Pairs[1] = Pairs2;
   if (NumPairs > 2) Pairs[2] = Pairs3;
   if (NumPairs > 3) Pairs[3] = Pairs4;
   if (NumPairs > 4) Pairs[4] = Pairs5;
   if (NumPairs > 5) Pairs[5] = Pairs6;
   if (NumPairs > 6) Pairs[6] = Pairs7;
   if (NumPairs > 7) Pairs[7] = Pairs8;
   if (NumPairs > 8) Pairs[8] = Pairs9;
   if (NumPairs > 9) Pairs[9] = Pairs10;
   if (NumPairs > 10) Pairs[10] = Pairs11;
   if (NumPairs > 11) Pairs[11] = Pairs12;
   if (NumPairs > 12) Pairs[12] = Pairs13;
   if (NumPairs > 13) Pairs[13] = Pairs14;
   GetLastError();
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit,err;
   
   int counted_bars = IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   err=GetLastError();
   if (err==4066) {
      counted_bars=0;
      Recalculate=true;
   }
   else {
      if (Recalculate) {
         counted_bars=0;
         Recalculate=false;
      }
   }
   limit = Bars - counted_bars-1;
   int i, j;
   double kk0, kk1;
   if (limit>Limit && Limit>0) limit=Limit;
   for(i = limit; i > -1; i--) {
      kk0 = 0.0;
      kk1 = 0.0;
      int timebar=iTime(NULL,TF,i);
      
      for(j = 0; j < NumPairs; j++) {
         int shift=iBarShift(Pairs[j],TF,timebar);
         if (iTime(NULL,TF,i)<iTime(Pairs[j],TF,shift)) shift++;
         kk0 = kk0 + iRVI(Pairs[j],TF, rvi_per,0, shift);
         kk1 = kk1 + iRVI(Pairs[j], TF,rvi_per,1, shift);
      }
      buf0[i] = kk0/NumPairs;
      buf1[i] = kk1/NumPairs;
   }
   return(0);
}

